<?php

namespace Dipendra\Programming\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Dipendra\Programming\Interfaces\ChapterRepositoryInterface;

class ChapterPublicController extends BaseController
{
    // use ChapterWorkflow;

    /**
     * Constructor.
     *
     * @param type \Dipendra\Chapter\Interfaces\ChapterRepositoryInterface $chapter
     *
     * @return type
     */
    public function __construct(ChapterRepositoryInterface $chapter)
    {
        $this->repository = $chapter;
        parent::__construct();
    }

    /**
     * Show chapter's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $chapters = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('programming::public.chapter.index', compact('chapters'))->render();
    }

    /**
     * Show chapter.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $chapter = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('programming::public.chapter.show', compact('chapter'))->render();
    }

}
