<?php

namespace Dipendra\Programming\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Dipendra\Programming\Interfaces\CourseRepositoryInterface;

class CoursePublicController extends BaseController
{
    // use CourseWorkflow;

    /**
     * Constructor.
     *
     * @param type \Dipendra\Course\Interfaces\CourseRepositoryInterface $course
     *
     * @return type
     */
    public function __construct(CourseRepositoryInterface $course)
    {
        $this->repository = $course;
        parent::__construct();
    }

    /**
     * Show course's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $courses = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('programming::public.course.index', compact('courses'))->render();
    }

    /**
     * Show course.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $course = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('programming::public.course.show', compact('course'))->render();
    }

}
