<?php

namespace Dipendra\Programming\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Dipendra\Programming\Interfaces\TutorialRepositoryInterface;

class TutorialPublicController extends BaseController
{
    // use TutorialWorkflow;

    /**
     * Constructor.
     *
     * @param type \Dipendra\Tutorial\Interfaces\TutorialRepositoryInterface $tutorial
     *
     * @return type
     */
    public function __construct(TutorialRepositoryInterface $tutorial)
    {
        $this->repository = $tutorial;
        parent::__construct();
    }

    /**
     * Show tutorial's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $tutorials = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('programming::public.tutorial.index', compact('tutorials'))->render();
    }

    /**
     * Show tutorial.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $tutorial = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('programming::public.tutorial.show', compact('tutorial'))->render();
    }

}
