<?php

namespace Dipendra\Programming;

use User;

class Programming
{
    /**
     * $course object.
     */
    protected $course;
    /**
     * $chapter object.
     */
    protected $chapter;
    /**
     * $tutorial object.
     */
    protected $tutorial;

    /**
     * Constructor.
     */
    public function __construct(\Dipendra\Programming\Interfaces\CourseRepositoryInterface $course,
        \Dipendra\Programming\Interfaces\ChapterRepositoryInterface $chapter,
        \Dipendra\Programming\Interfaces\TutorialRepositoryInterface $tutorial)
    {
        $this->course = $course;
        $this->chapter = $chapter;
        $this->tutorial = $tutorial;
    }

    /**
     * Returns count of programming.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.course.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->course->pushCriteria(new \Litepie\Dipendra\Repositories\Criteria\CourseUserCriteria());
        }

        $course = $this->course->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('programming::' . $view, compact('course'))->render();
    }
    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.chapter.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->chapter->pushCriteria(new \Litepie\Dipendra\Repositories\Criteria\ChapterUserCriteria());
        }

        $chapter = $this->chapter->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('programming::' . $view, compact('chapter'))->render();
    }
    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.tutorial.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->tutorial->pushCriteria(new \Litepie\Dipendra\Repositories\Criteria\TutorialUserCriteria());
        }

        $tutorial = $this->tutorial->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('programming::' . $view, compact('tutorial'))->render();
    }
}
