<?php

namespace Dipendra\Programming\Providers;

use Illuminate\Contracts\Auth\Access\Gate as GateContract;
use Illuminate\Foundation\Support\Providers\AuthServiceProvider as ServiceProvider;

class AuthServiceProvider extends ServiceProvider
{
    /**
     * The policy mappings for the package.
     *
     * @var array
     */
    protected $policies = [
        // Bind Course policy
        \Dipendra\Programming\Models\Course::class => \Dipendra\Programming\Policies\CoursePolicy::class,
// Bind Chapter policy
        \Dipendra\Programming\Models\Chapter::class => \Dipendra\Programming\Policies\ChapterPolicy::class,
// Bind Tutorial policy
        \Dipendra\Programming\Models\Tutorial::class => \Dipendra\Programming\Policies\TutorialPolicy::class,
    ];

    /**
     * Register any package authentication / authorization services.
     *
     * @param \Illuminate\Contracts\Auth\Access\Gate $gate
     *
     * @return void
     */
    public function boot(GateContract $gate)
    {
        parent::registerPolicies($gate);
    }
}
