<?php

namespace Dipendra\Programming\Workflow;

use Dipendra\Programming\Models\Chapter;
use Dipendra\Programming\Notifications\Chapter as ChapterNotifyer;
use Notification;

class ChapterNotification
{

    /**
     * Send the notification to the users after complete.
     *
     * @param Chapter $chapter
     *
     * @return void
     */
    public function complete(Chapter $chapter)
    {
        return Notification::send($chapter->user, new ChapterNotifyer($chapter, 'complete'));;
    }

    /**
     * Send the notification to the users after verify.
     *
     * @param Chapter $chapter
     *
     * @return void
     */
    public function verify(Chapter $chapter)
    {
        return Notification::send($chapter->user, new ChapterNotifyer($chapter, 'verify'));;
    }

    /**
     * Send the notification to the users after approve.
     *
     * @param Chapter $chapter
     *
     * @return void
     */
    public function approve(Chapter $chapter)
    {
        return Notification::send($chapter->user, new ChapterNotifyer($chapter, 'approve'));;

    }

    /**
     * Send the notification to the users after publish.
     *
     * @param Chapter $chapter
     *
     * @return void
     */
    public function publish(Chapter $chapter)
    {
        return Notification::send($chapter->user, new ChapterNotifyer($chapter, 'publish'));;
    }

    /**
     * Send the notification to the users after archive.
     *
     * @param Chapter $chapter
     *
     * @return void
     */
    public function archive(Chapter $chapter)
    {
        return Notification::send($chapter->user, new ChapterNotifyer($chapter, 'archive'));;

    }

    /**
     * Send the notification to the users after unpublish.
     *
     * @param Chapter $chapter
     *
     * @return void
     */
    public function unpublish(Chapter $chapter)
    {
        return Notification::send($chapter->user, new ChapterNotifyer($chapter, 'unpublish'));;

    }
}
