<?php

namespace Dipendra\Programming\Workflow;

use Dipendra\Programming\Models\Course;
use Dipendra\Programming\Notifications\Course as CourseNotifyer;
use Notification;

class CourseNotification
{

    /**
     * Send the notification to the users after complete.
     *
     * @param Course $course
     *
     * @return void
     */
    public function complete(Course $course)
    {
        return Notification::send($course->user, new CourseNotifyer($course, 'complete'));;
    }

    /**
     * Send the notification to the users after verify.
     *
     * @param Course $course
     *
     * @return void
     */
    public function verify(Course $course)
    {
        return Notification::send($course->user, new CourseNotifyer($course, 'verify'));;
    }

    /**
     * Send the notification to the users after approve.
     *
     * @param Course $course
     *
     * @return void
     */
    public function approve(Course $course)
    {
        return Notification::send($course->user, new CourseNotifyer($course, 'approve'));;

    }

    /**
     * Send the notification to the users after publish.
     *
     * @param Course $course
     *
     * @return void
     */
    public function publish(Course $course)
    {
        return Notification::send($course->user, new CourseNotifyer($course, 'publish'));;
    }

    /**
     * Send the notification to the users after archive.
     *
     * @param Course $course
     *
     * @return void
     */
    public function archive(Course $course)
    {
        return Notification::send($course->user, new CourseNotifyer($course, 'archive'));;

    }

    /**
     * Send the notification to the users after unpublish.
     *
     * @param Course $course
     *
     * @return void
     */
    public function unpublish(Course $course)
    {
        return Notification::send($course->user, new CourseNotifyer($course, 'unpublish'));;

    }
}
